import memgn
import scipy
import numpy
import scipy.optimize

def reo(x):
    a = numpy.array(x)
    b =  memgn.obj(a[0], a[1], a[2], a[3])
    return b

def gradreo(x):
    a = numpy.array(x)
    g = []
    g.append(memgn.gradobj0(a[0], a[1], a[2], a[3]))
    g.append(memgn.gradobj1(a[0], a[1], a[2], a[3]))
    g.append(memgn.gradobj2(a[0], a[1], a[2], a[3]))
    g.append(memgn.gradobj3(a[0], a[1], a[2], a[3]))
    return numpy.array(g)

o = scipy.optimize.fmin_slsqp(reo, [1.0, 1.0, 1.0, 1.0])
# o = scipy.optimize.fmin_slsqp(reo, [1.32788523e+00, 6.17840958e-01, 1.67791010e-05, 1.92249964e+00])

print o
