#include "memorialy.h"
#include "equationd.h"
#include "caseconst.h"

using namespace std;

namespace matrixlength
{
  int m = V_DAY + 1;
}

double f(double x[])
{
   using matrixlength::m;
   double y[m][2];
   readtsvfile(y, m, "myfile.tsv");
   double w[m];
   sim(w, m, x);
   double e[m];
   for (int i=0; i<m; i++)
     {
	e[i] = y[i][1] - w[i];
     }
   return nor(e, m);
}

void gradf(double x[], double y[], int n, double h)
{
   double z1[n];
   double z2[n];
   double z3[n];
   double z4[n];
   for (int i=0; i<n; i++)
     {
	cop(x, z1, n);
	cop(x, z2, n);
	cop(x, z3, n);
	cop(x, z4, n);
	z1[i] = x[i]-(2.*h);
	z2[i] = x[i]-h;
	z3[i] = x[i]+h;
	z4[i] = x[i]+(2.*h);
	y[i] = (1./(12.*h))*(f(z1)-(8.*f(z2))+(8.*f(z3))-f(z4));
     }
}

double obj(double x0, double x1, double x2, double x3)
{
   double x[4];
   x[0] = x0;
   x[1] = x1;
   x[2] = x2;
   x[3] = x3;
   return f(x);
}

double gradobj0(double x0, double x1, double x2, double x3)
{
   double x[4];
   x[0] = x0;
   x[1] = x1;
   x[2] = x2;
   x[3] = x3;
   double y[4];
   y[0] = 0.0;
   y[1] = 0.0;
   y[2] = 0.0;
   y[3] = 0.0;
   int n = 4;
   double h = 1.e-9;
   gradf(x, y, n, h);
   return y[0];
}

double gradobj1(double x0, double x1, double x2, double x3)
{
   double x[4];
   x[0] = x0;
   x[1] = x1;
   x[2] = x2;
   x[3] = x3;
   double y[4];
   y[0] = 0.0;
   y[1] = 0.0;
   y[2] = 0.0;
   y[3] = 0.0;
   int n = 4;
   double h = 1.e-9;
   gradf(x, y, n, h);
   return y[1];
}

double gradobj2(double x0, double x1, double x2, double x3)
{
   double x[4];
   x[0] = x0;
   x[1] = x1;
   x[2] = x2;
   x[3] = x3;
   double y[4];
   y[0] = 0.0;
   y[1] = 0.0;
   y[2] = 0.0;
   y[3] = 0.0;
   int n = 4;
   double h = 1.e-9;
   gradf(x, y, n, h);
   return y[2];
}

double gradobj3(double x0, double x1, double x2, double x3)
{
   double x[4];
   x[0] = x0;
   x[1] = x1;
   x[2] = x2;
   x[3] = x3;
   double y[4];
   y[0] = 0.0;
   y[1] = 0.0;
   y[2] = 0.0;
   y[3] = 0.0;
   int n = 4;
   double h = 1.e-9;
   gradf(x, y, n, h);
   return y[3];
}
