#include <cmath>
#include <iostream>
#include <string>
#include <fstream>
#include <cstdlib>

using namespace std;

void sum(double x[], double y[], double z[], int n)
{
	for (int i=0; i<n; i++)
	{
		z[i] = x[i] + y[i];
	}
}

void mul(double x[], double y[], double no, int n)
{
	for (int i=0; i<n; i++)
	{
		y[i] = x[i] * no;
	}
}

double sca(double x[], double y[], int n)
{
   double sca_prd = 0;
   for (int i=0; i<n; i++)
     {
	sca_prd += x[i] * y[i];
     }
   return sca_prd;
}

double no1(double x[], int n)
{
   double norm = 0;
   for (int i=0; i<n; i++)
     {
	norm += fabs(x[i]);
     }
   return norm;
}

double nor(double x[], int n)
{
   double norm = 0;
   for (int i=0; i<n; i++)
     {
	norm += x[i] * x[i];
     }
   return sqrt(norm);
}

void cop(double x[], double y[], int n)
{
	for (int i=0; i<n; i++)
	{
		y[i] = x[i];
	}
}

bool dif(double x[], double y[], int n)
{
   for (int i=0; i<n; i++)
     {
	if (x[i] != y[i])
	  return true;
     }
   return false;
}

void readtsvfile(double x[][2], int n, char file_name[])
{
   ifstream file(file_name);
   int i;
   i = 0;
   if ( file.is_open() )
     {
	i = 0;
	while ( !file.eof() && i < n )
	  {
	     for (int j=0; j<2; j++)
	        file >> x[i][j];
	     i++;
	  }
	file.close();
     }
   else
     cout << "File " << file_name << " could not be opened." << "\n";
}

void sav(int counter, double x[], int n, double f)
{
   ofstream file("reo-res.txt");
   if ( file.is_open() )
     {
	file << counter << " " << x[0] << " " << x[1] << " " << x[2] << " " << x[3] << " " << f << "\n";
     }
   else
     {
	cout << "Failed on recording parameters: iteration " << counter << ".\n";
     }
   file.close();
}

double defhby(int i)
{
   //Use 5 for chernobyl.
   //Use 3 for concorde.
   //if (i<5)
   return 0.1;
   //if (i==5)
   //  return 2.;
   //else
   //  return 3.;
}
