#include <cmath>
#include "memorialy.h"

double f(double x[])
{
   //using matrixlength::m;
   int m = 7271;
   double y[m][2];
   readtsvfile(y, m, "myfile.tsv");
   double deltah = 0.1;
   double e[m-1];
   //Use these parameters for chernobyl.
   double Qo = 23.;
   double No = 2880.;
   //Use these parameters for concorde.
   //double Qo = 21.;
   //double No = 20800.;
   for (int i=1; i<m; i++)
     {
	deltah = defhby(int(y[i][0]));
	e[i-1] =

	 -y[i][1]   +
	  y[i-1][1] +
	  (deltah/2.)     *
	  (
	   -(
	     ( x[0] + (x[1]*exp(-x[2]*y[i-1][0])) ) * (Qo/No) * pow(y[i-1][1],2)
	    )

	   -(
	     ( x[3] - ( x[0] + (x[1]*exp(-x[2]*y[i-1][0])) ) ) * y[i-1][1]
	    )

	   -(
	     ( x[0] + (x[1]*exp(-x[2]*y[i][0])) ) * (Qo/No) * pow(y[i][1],2)
	    )

	   -(
	     ( x[3] - ( x[0] + (x[1]*exp(-x[2]*y[i][0])) ) ) * y[i][1]
	    )
	  );
     }
   return nor(e, m-1);
}

double obj(double x0, double x1, double x2, double x3)
{
   double x[4];
   x[0] = x0;
   x[1] = x1;
   x[2] = x2;
   x[3] = x3;
   return f(x);
}
